# flame for ship exhaust

import pygame
from pygame.locals import *
import game, gfx
from basespriteobj import *

name = 'flame'
images = []

def load_game_resources():
    global name, images
    for loop in range(0,4):
        images.append(gfx.load('%s%d.gif'%(name,loop)))

class Flame(Sprite):
    def __init__(self,playership):
        global images

        Sprite.__init__(self)
        
        self.imagenum = 0
        self.images = images
        self.numimages = len(images)
        self.image = self.images[self.imagenum]
        self.rect = self.images[0].get_rect()
        self.lastrect = self.rect
        self.playership = playership
        self.xoffset = -self.rect.width - 1
        self.yoffset = 0
        self.interval = game.flame_interval
        self.x = self.playership.x + self.xoffset
        self.y = self.playership.y + self.yoffset
        self.rect.topleft = self.x,self.y
        self.timer = 0


    def tick(self, speedadjust):
        self.x = self.playership.x + self.xoffset
        self.y = self.playership.y + self.yoffset
        self.rect.topleft = self.x,self.y
        self.timer = (self.timer + 1 ) % self.interval
        if self.timer == 0:
            self.imagenum = (self.imagenum + 1) % self.numimages
            self.image = self.images[self.imagenum]
